#if !defined(AFX_PREFERENCESTASKCALCPAGE_H__84CBF881_D8CA_4D00_ADD6_1DCB7DE71C5B__INCLUDED_)
#define AFX_PREFERENCESTASKCALCPAGE_H__84CBF881_D8CA_4D00_ADD6_1DCB7DE71C5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PreferencesTaskPage.h : header file
//

#include "..\shared\groupline.h"
#include "..\shared\dialoghelper.h"
#include "..\shared\preferencesbase.h"

enum
{
	PTCP_REMAININGTTIMEISDUEDATE,
	PTCP_REMAININGTTIMEISSPENT,
	PTCP_REMAININGTTIMEISPERCENTAGE,
};

/////////////////////////////////////////////////////////////////////////////
// CPreferencesTaskCalcPage dialog

class CPreferencesTaskCalcPage : public CPreferencesPageBase, public CDialogHelper
{
	DECLARE_DYNCREATE(CPreferencesTaskCalcPage)

// Construction
public:
	CPreferencesTaskCalcPage();
	~CPreferencesTaskCalcPage();

	BOOL GetAveragePercentSubCompletion() const { return m_bAveragePercentSubCompletion; }
	BOOL GetIncludeDoneInAverageCalc() const { return m_bIncludeDoneInAverageCalc; }
	BOOL GetUseEarliestDueDate() const { return m_bUseEarliestDueDate; }
	BOOL GetUsePercentDoneInTimeEst() const { return m_bUsePercentDoneInTimeEst; }
	BOOL GetTreatSubCompletedAsDone() const { return m_bTreatSubCompletedAsDone; }
	BOOL GetUseHighestPriority() const { return m_bUseHighestPriority; }
	BOOL GetUseHighestRisk() const { return m_bUseHighestPriority; } // Note: this uses same flag as priority
	BOOL GetAutoCalcTimeEstimates() const { return m_bAutoCalcTimeEst; }
	BOOL GetIncludeDoneInPriorityRiskCalc() const { return m_bIncludeDoneInPriorityRiskCalc; }
	BOOL GetWeightPercentCompletionByNumSubtasks() const { return m_bWeightPercentCompletionByNumSubtasks; }
	BOOL GetAutoCalcPercentDone() const { return m_bAutoCalcPercentDone; }
	BOOL GetAutoAdjustDependents() const { return m_bAutoAdjustDependents; }
	BOOL GetDueTasksHaveHighestPriority() const { return m_bDueTasksHaveHighestPriority; }
	BOOL GetDoneTasksHaveLowestPriority() const { return m_bDoneTasksHaveLowestPriority; }
	BOOL GetDoneTasksHaveLowestRisk() const { return m_bDoneTasksHaveLowestPriority; } // Note: this uses same flag as priority
	BOOL GetNoDueDateIsDueToday() const { return m_bNoDueDateDueToday; }
	int GetTimeRemainingCalculation() const { return m_nCalcRemainingTime; }

//	BOOL Get() const { return m_b; }

protected:
// Dialog Data
	//{{AFX_DATA(CPreferencesTaskCalcPage)
	enum { IDD = IDD_PREFTASKCALC_PAGE };
	BOOL	m_bTreatSubCompletedAsDone;
	BOOL	m_bUseHighestPriority;
	BOOL	m_bAutoCalcTimeEst;
	BOOL	m_bIncludeDoneInPriorityRiskCalc;
	BOOL	m_bAutoCalcPercentDone;
	BOOL	m_bAutoAdjustDependents;
	BOOL	m_bWeightPercentCompletionByNumSubtasks;
	BOOL	m_bDueTasksHaveHighestPriority;
	BOOL	m_bDoneTasksHaveLowestPriority;
	BOOL	m_bNoDueDateDueToday;
	int		m_nCalcRemainingTime;
	//}}AFX_DATA
	BOOL	m_bUseEarliestDueDate;
	BOOL	m_bUsePercentDoneInTimeEst;
	BOOL	m_bAveragePercentSubCompletion;
	BOOL	m_bIncludeDoneInAverageCalc;

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPreferencesTaskCalcPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPreferencesTaskCalcPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnUsehighestpriority();
	afx_msg void OnAutocalcpercentdone();
	//}}AFX_MSG
	afx_msg void OnAveragepercentChange();
	DECLARE_MESSAGE_MAP()

   virtual void LoadPreferences(const CPreferences& prefs);
   virtual void SavePreferences(CPreferences& prefs);

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PREFERENCESTASKCALCPAGE_H__84CBF881_D8CA_4D00_ADD6_1DCB7DE71C5B__INCLUDED_)
